%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                                                       
%                                                                                                       %
% 1. Ausgehend von der Grammatik in Kapitel 8, die einen Ableitungsbaum zu einem                        %
% gegebenen String generiert, schreibe ein Prädikat parse/1, das prüft, ob ein Satz                     %
% von der Grammatik generiert wird und wenn ja, den Ableitungsbaum mithilfe von pprint/1                %
% auf dem Bildschirm ausgibt.                                                                           %
% 2. Schreibe ein Prädikat pprint_list/1, das eine Liste als Argument nimmt und die                     %
% Elemente der Liste nacheinander auf dem Bildschirm ausgibt ohne die Klammern und                      %                   
% die Kommata der Liste.                                                                                %
% 3. Erweitere das Prädikat parse/1 um pprint_list/1, so dass neben dem Ableitungsbaum                  %
% auch der Satz ausgegeben wird.                                                                        %
% 4. Um nicht jedesmal wieder an der Konsole ganze Sätze eingeben zu müssen, schreibe nummerierte       %
% Beispielsätze in die Wissensbasis:                                                                    %                
% ex(1,[die,katze,jagt,eine,maus]).                                                                     %
% ex(2,[die,katze,jagt,eine,maus,und,maeuse,klauen,katzen]).                                            %
% Schreibe ein Prädikat test/1, das eine Zahl als Argument nimmt und den Beispielsatz mit               %                  
% der entsprechenden Nummer an ihr Prädikat parse/1 weiterleitet.                                       %
%                                                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Die folgenden Codezeilen sind nur notwendig, wenn tab/1 nicht intern definiert ist, wie bei SWISH zum Beispiel
% redefined tab:
% src: https://github.com/SWI-Prolog/swish/issues/119
:- dynamic tab/1.
tab(0) :- !.
tab(X) :- X \== 0, write('\x2001'), Y is X-1, tab(Y).

% LÖSUNG
% pprint/1

pprint(Term):- pprint(Term ,0).                                 % Das Programm wird beendet, sobald keine Eingabe mehr erfolgtMM

pprint(Term ,N):-                                               % Eine Ausgabe erfolgt, wenn
             Term =.. [F| Args ],                               % prüft ob der Term generierbar ist,
             tab(N),                                            % ein Tab eingefügt wird,
             write(F),                                          % die Elemente ausgebbar sind,
             nl,                                                % eine neue Zeile ausgegeben wird, 
             N1 is N+3 ,                                        % ein Tab aus drei Leerzeichen besteht und
             pprintl(Args ,N1).                                 % die Argumente mit Abstand von 3 Leerzeichen ausgegeben werden.

pprintl([H|T] ,N):-                                             % wenn in der Liste noch ein Element steht, dann
             pprint(H,N),                                       % wird dieses Element ausgegeben und
             pprintl(T,N).                                      % der Rest rekursiv aufgerufen
             pprintl([] ,_).                                    % bis die Liste leer ist

% Grammatikregeln mit Parser (siehe Foliensatz 8):
s(s(NP, VP)) --> np(NP,(nom,Num,_)), vp(VP,Num).
np(np(Det, N),KNG) --> det(Det, KNG), n(N, KNG).
vp(vp(V, NP),Num) --> v(V, Num), np(NP, (akk,_,_)).

% Lexikon:
det(det(der),(nom,sing,mas)) --> [der].
det(det(den),(akk,sing,mas)) --> [den].
det(det(die),(_,sing,fem)) --> [die].
det(det(das),(_,sing,neu)) --> [das].
det(det(die),(_,plur,_)) --> [die].
det(det([]),(_,plur,_)) --> [].
n(n(maus),(_,sing,fem)) --> [maus].
n(n(maeuse),(_,plur,_)) --> [maeuse].
n(n(katze),(_,sing,fem)) --> [katze].
n(n(katzen),(_,plur,_)) --> [katzen].
n(n(hund),(_,sing,mas)) --> [hund].
n(n(hunde),(_,plur,mas)) --> [hunde].
n(n(pferd),(_,sing,neu)) --> [pferd].
n(n(pferde),(_,plur,neu)) --> [pferde].
v(v(jagt),sing) --> [jagt].
v(v(jagen),plur) --> [jagen].

ex(1, [die, katze, jagt, das, pferd]).
ex(2,[die, hunde, jagen, den, hund]).
ex(3,[die, maus, jagt, die, pferde]).


% parse/1

parse(S) :- s(T, S, []),                                % Ein Satz S kann von der Grammatik generiert werden, wenn
            pprint_list(S),                             % die eingelese Liste mit pprint_list(S) ausgegeben werden kann und
            nl,                                         % eine neue Zeile ausgegeben wird und
            pprint(T).                                  % und der Ableitungsbaum auf dem Bildschirm ausgegeben werden kann


% pprint_list/1

pprint_list([]).                                        % Die Aussgabe wird beendet, wenn die Liste leer ist.
pprint_list([H|T]) :- write(H),                         % Die Liste in Head und Tail unterteilt, sodass der Head 
                      tab(1),                           % immer gefolgt von einem Tab ausgegeben wird
                      pprint_list(T).                   % und der Tail rekursiv abgearbeit wird.

% test/1

test(N) :- ex(N,S),                                     % übermittel die Nr. des Bsp.satzes, sodass
           parse(S).                                    % dieser als Baum ausgegeben werden kann
