%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                                                                      
%                                                                                       %
% Schreibe ein zweistelliges Prädikat termtype(+Term,?Type), das gelingt,               %
% wenn Type der Typ (atom, number, constant, variable etc.) des Terms Term ist.         %
% Hierbei sollen alle Typen, zu denen der Term gehört (beginnend mit dem                %
% spezifischsten) zurückgegeben werden (siehe Foliensatz 9, Folie 38).                  %
%                                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% termtype(+Term, ?Type)

termtype(X, int) :- integer(X).                                 % X ist ein int, wenn X ein Integer ist
termtype(X, number) :- number(X).                               % X ist eine number, wenn X eine Number ist
termtype(X, atom) :- atom(X).                                   % X ist ein atom, wenn X ein Atom ist
termtype(X, atomic) :- atomic(X).                               % X ist ein atomic, wenn X ein Atomic ist
termtype(X, variable) :- var(X).                                % X ist eine variable, wenn X eine Variable ist

termtype(X, complex_term) :- nonvar(X),                         % prüft, ob X eine uninstantiierte Variable ist,
                               functor(X,_,A),                  % und sortiert die Terme solange
                               A > 0.                           % A größer 0 ist

termtype(X, simple_term) :- not(termtype(X, complex_term)).     % X  ist ein einfacher Termn, wenn er nicht komplex ist

termtype(_X, term).                                             % X ist ein Term

